!----------------------------------------------------------------------
!     Copyright (c) 2002 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!ɽ  yt_module
!      ݥݥƥ󥷥Ȼ
!
!  2002/02/13  ݹ
!
program yt_diff4

  use lumatrix
  use yt_module
  use gtool_history
  implicit none

 !---- ֲ ----
  integer,parameter  :: im=32, jm=16, km=16  ! ʻ(, , ư)
  integer,parameter  :: nm=10, lm=16         ! ȿ(ʿ, ư)

 !---- ɸѿʤ ----
  real(8),parameter  :: ri=0.5, ro=1.5       ! ⳰Ⱦ

 !---- ѿ ----
  real(8), dimension(im,jm,0:km)     :: ggg_pvel   ! ݥ®
  real(8), dimension((nm+1)**2,0:lm) :: yt_pvel    ! ݥ®
  real(8), dimension(im,jm,0:km)     :: ggg_laplapvel   ! ݥ®
  real(8), dimension((nm+1)**2,0:lm) :: yt_laplapvel    ! ^2ݥ®

  real(8)             :: gg_pmagbndry(im,jm,2)     ! 
  real(8)             :: y_pmagbndry((nm+1)**2,2)  ! 

 !---- ʬѥ᥿ ----
  real(8), parameter :: dt=5e-5                 ! ֥ƥå״ֳ
  integer, parameter :: nt=10000, ndisp=1000    ! ʬ, ɽƥå

 !---- ʪѥ᥿ ----
  character(len=2), parameter :: velbc='RF'     ! ®ٶ(RR/RF/FR/FF)
  real(8), parameter :: nu=1.0                  ! Ǵ

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: lon1=pi                 ! ʬ۰ٺɸ
  real(8), parameter :: lat1=0.0                ! ʬ۷ٺɸ
  real(8), parameter :: rad1=(ri+ro)/2.0        ! ʬưºɸ
  real(8), parameter :: sigma=0.2               ! ʬۤ礭

 !---- ¾ ----
  integer :: it

 !---------------- ɸͤ ---------------------
  call yt_initial(im,jm,km,nm,lm,ri,ro)

 !-------------------  ----------------------
  ggg_pvel =  exp(-((ggg_lon-lon1)**2+(ggg_lat-lat1)**2+(ggg_rad-rad1)**2)&
                 /(2*sigma**2))
  yt_pvel = yt_ggg(ggg_pvel)
  yt_laplapvel = yt_lapla_yt(yt_pvel)
  ggg_laplapvel = ggg_yt(yt_laplapvel)

  call output_gtool4_init
  call output_gtool4

 !------------------- ʬ ----------------------
  do it=1,nt                                         ! Euler ˡˤʬ
     yt_laplapvel = yt_laplapvel + dt *( nu * yt_lapla_yt(yt_laplapvel))
     yt_pvel = yt_yg(yg_laplapol2pol_yg(yg_yt(yt_laplapvel),cond=velbc))
     yt_laplapvel = yt_lapla_yt(yt_pvel)

     if(mod(it,ndisp) .eq. 0)then                    ! 
        ggg_pvel = ggg_yt(yt_pvel)
        ggg_laplapvel = ggg_yt(yt_laplapvel)
        call output_gtool4
     endif
  enddo
  call output_gtool4_close

contains

 !-------------------  ----------------------
  subroutine output_gtool4_init
    call HistoryCreate( &                                  ! ҥȥ꡼
           file='yt_diff4.nc', title='Diffusion model in a spherical shell', &
           source='Sample program of spmodel library', &
           institution='GFD_Dennou Club SPMODEL project',     &
           dims=(/'lon','lat','rad','t  '/), dimsizes=(/im,jm,km+1,0/),&
           longnames=(/'Longitude','Latitude ','Radius   ','time     '/),&
           units=(/'1','1','1','1'/),   &
           origin=0.0, interval=real(ndisp*dt) )

    call HistoryPut('lon',g_lon/pi*180)                       ! ѿ
    call HistoryPut('lat',g_lat/pi*180)                       ! ѿ
    call HistoryPut('rad',g_rad)                              ! ѿ

    call HistoryAddVariable( &                                ! ѿ
           varname='pvel', dims=(/'lon','lat','rad','t  '/), & 
           longname='poloidal velocity potential', units='1', xtype='double')
    call HistoryAddVariable( &                                ! ѿ
           varname='laplapvel', dims=(/'lon','lat','rad','t  '/), & 
           longname='laplacian poloidal velocity potential', units='1', xtype='double')
  end subroutine output_gtool4_init

  subroutine output_gtool4
    write(6,*) 'it = ',it
    call HistoryPut('t',real(it*dt))
    call HistoryPut('pvel',ggg_pvel)
    call HistoryPut('laplapvel',ggg_laplapvel)
  end subroutine output_gtool4

  subroutine output_gtool4_close
    call HistoryClose
  end subroutine output_gtool4_close

end program yt_diff4
